@echo off
title Starte ... "%~n0"
color 1f
setlocal enabledelayedexpansion

set power=0
if exist %temp%\%~n0.ps1 del %temp%\%~n0.ps1
for /f "tokens=*" %%l in ('type "%~f0"') do (
  if !power!==0 (
    if "%%l"=="*** Ab hier PowerShell ***" set power=1
  ) else (
    echo %%l >> "%temp%\%~n0.ps1"
  )
)
cls
rem echo Starte "%~n0" 
title "%~n0" läuft  ...
powershell -NoProfile -ExecutionPolicy Bypass -File "%temp%\%~n0.ps1" %*
rem TIMEOUT /T 30 /nobreak 
del "%temp%\%~n0.ps1"
rem timeout /t 30
rem pause
exit /b

*** Ab hier PowerShell ***
# Show running .NET-Version
# Stop-Process -Name notepad -Force -ErrorAction SilentlyContinue
$execruntime = [System.Reflection.Assembly]::GetExecutingAssembly().ImageRuntimeVersion
#
$ExportPath = $env:TEMP
$ExportFile = "software-info-$env:Username@$env:computername"
Remove-Item $ExportPath\$ExportFile -Force -ErrorAction SilentlyContinue
#

# ---- Ausgabe --- START ------ 
$DateTXT = Get-Date -format "dd.MM.yyyy - HH:mm:ss tt"
Write-Output "------------------------------------------------------------------" | Out-File "$ExportPath\$ExportFile" -Encoding utf8
Write-Output "Software-Info Tool - Ver. 1.2.4 (12.01.2024) / .NET Runtime $execruntime" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "Download https:\\www.hekret.de\pcinfo" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "------------------------------------------------------------------`r`n" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
# Write-Output "`n" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "Erstellt von Benutzer '$env:userdomain\$env:USERNAME'`r`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
Write-Output "Datensatz erstellt am $DateTXT`r`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#

Write-Host "------------------------------------------------------------------"
Write-Host "Software-Info Tool - Ver. 1.2.4 (12.01.2024) / .NET Runtime $execruntime"
Write-Host "Download https:\\www.hekret.de\pcinfo"
Write-Host "------------------------------------------------------------------`r`n"

# --- Info Machine / User --- START ---
$machinename = (Get-CimInstance -Class:Win32_Computersystem).Name
$domain = (Get-CimInstance Win32_ComputerSystem).Domain

# ActiveDirectory Site abfragen und Fehler abfangen.
try {
    $adsite = [System.DirectoryServices.ActiveDirectory.ActiveDirectorySite]::GetComputerSite().Name
    }
    catch
    {
    # Write-Host $PSItem.Exception.Message
    Set-Variable -Name adsite -Value "-"
    }
#
#
$dr = Get-CimInstance -Class win32_computersystem | Select-Object -ExpandProperty domainrole
$domainrole = switch ($dr) {
    0 {"Standalone Workstation"} 
    1 {"Member Workstation"} 
    2 {"Standalone Server"} 
    3 {"Member Server"} 
    4 {"Backup Domain Controller"} 
    5 {"Primary Domain Controller"} 
    default {"Unknown"} 
    } # end switch



write-Output "
Domain Machine Info:`
    Computername: ............... $machinename`
    ActiveDirectory: ............ $domain`
    Site: ....................... $adsite`
    Domain Role: ................ $domainrole`
`
Domain User Info:`
    ActiveDirectory: ............ $env:userdomain`
    LogonServer: ................ $env:logonserver`
    UserName: ................... $env:USERNAME`
    `
    `
    " | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append

# --- Info Machine / User --- END ---

# Write-Host "Status:`n"
Write-Host "collecting Data ...  / sammle Daten ...`r`n"
#
Write-Host "Software + Apps (Userprofile / 64-Bit / 32-Bit)`n"
Write-Output "---- Software / Programme (Userprofile / Benutzerprofil - 64-Bit - 32-Bit) ----- START -----`n`n" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
#
# Get-CimInstance -Class Win32_Product | Select-Object -Property Name,Version,Vendor,IdentifyingNumber | Format-Table -AutoSize)
#
# Software-List UserProfile
Write-Host "-- Windows - Software-List (UserProfile) --`n"
Write-Output "##-- Windows - Software-List (UserProfile) --##" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
Get-ItemProperty HKCU:\Software\Microsoft\Windows\CurrentVersion\Uninstall\* | Where-Object { ($_.DisplayName -gt "0" ) } | `
	Select-Object DisplayName, DisplayVersion, Publisher, InstallDate | Sort-Object -Property DisplayName | Format-Table -AutoSize -Wrap | `
	Out-File -Width 500 -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
# Write-Output "------- Windows - Software-List (UserProfile) ------- END --------" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#
write-Output "`n`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#
# Apps-List UserProfile (without/ohne FrameWorks, NonRemovable-Apps)
Write-Host "-- Windows - Apps-List (User) --`n"
Write-Output "##-- Windows - Apps-List (User) (without/ohne FrameWorks, NonRemovable-Apps) --##" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
$curruser = $env:username
Get-AppxPackage -User $curruser | `
Where-Object  -FilterScript { ($PSItem.NonRemovable -eq $False) -and  ($PSItem.IsFramework -eq $False)  } | `
Select-Object Name,Architecture,Version,PackageFullName,PackageFamilyName,Publisher,PublisherId,InstallLocation | `
Sort-Object -Property Name | Format-Table -AutoSize -Wrap | Out-File -Width 500 -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
# Write-Output "------- Windows - Apps-List (UserProfile) ------- END --------" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#
write-Output "`n`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#
# FrameWork Apps
Write-Host "-- Windows - FrameWork Apps --`n"
Write-Output "##-- Windows - FrameWork Apps --##" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
Get-AppxPackage | `
	Where-Object  -FilterScript { ($PSItem.IsFramework -eq $True) } | `
	Select-Object Name,Architecture,Version,NonRemovable,PackageFullName,PackageFamilyName,Publisher,PublisherId | `
	Sort-Object -Property Name | Sort-Object -Property Name | Format-Table -AutoSize -Wrap | `
	Out-File -Width 500 -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
# Write-Output "------- Windows - FrameWork Apps ------- END --------" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#
write-Output "`n`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#
# 64 Software-List @ 64-Bit Windows
# 32 Software-List @ 32-Bit Windows 
Write-Host "-- Windows Native - 64-bit - Software-List (Machine) --`n"
write-Output "##-- Windows Native - 64-bit - Software-List (Machine) --##" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
Get-ItemProperty HKLM:\Software\Microsoft\Windows\CurrentVersion\Uninstall\* | Where-Object { ($_.DisplayName -gt "0" ) } | `
	Select-Object DisplayName, DisplayVersion, Publisher, InstallDate | Sort-Object -Property DisplayName | Format-Table -AutoSize -Wrap | `
	Out-File -Width 500 -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#
write-Output "`n`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
# 32-Bit Software-List @ 64-Bit Windows
#
Write-Host "-- Windows - 32-Bit - Software-List (Machine) --`n"
Write-Output "## -- Windows - 32-Bit - Software-List (Machine) -- ##-- START -----" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
Get-ItemProperty HKLM:\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\* | Where-Object { ($_.DisplayName -gt "0" ) } | `
	Select-Object DisplayName, DisplayVersion, Publisher, InstallDate | Sort-Object -Property DisplayName | Format-Table -AutoSize -Wrap | `
	Out-File -Width 500 -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#
Write-Host "------------------------------------------------------------------`r`n"
write-Output "`n`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
Write-Output "--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--`r`n" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
#
# ------------------- Software List ---------------- END -------------------
#

# ---- Ausgabe --- END ------ 
#
$DateTXT = Get-Date -format "dd.MM.yyyy - HH:mm:ss tt"
Write-Output "------------------------------------------------------------------" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "Erfassung abgeschlossen: $DateTXT" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "------------------------------------------------------------------`r`n" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "_______________ - End of File - ______________________`r`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#
# Get-Content $ExportPath\$ExportFile
# pause
Start-Process notepad.exe $ExportPath\$ExportFile
